#include <stdio.h>
#include <queue>
#include <string.h>
//#include <set>

using namespace std;

int k;
char buf[100050];

char lcase(char c) {
    if(c<='Z' && c>='A')
	return c-'A'+'a';
    else
        return c;
}

bool isAlpha(char c) {
    return lcase(c)>='a' && lcase(c)<='z';
}

char hmap[1000010];

int hashFunc(char* cm) {
    int res=0;
    for(int i=0;i<26;i++)
	res^=cm[i]<<i;
    return res%1000000;
}

int hashFunc2(char* cm) {
    int res=0;
    for(int i=0;i<26;i++)
	res^=3*cm[i]<<i;
    return res%253+1;
}

void htInsert(char* cm) {
    int h1=hashFunc(cm);
    int h2=hashFunc2(cm);
    while(hmap[h1]!=0) h1=h1*3%1000000;
    hmap[h1]=h2;
}

bool htContains(char* cm) {
    int h1=hashFunc(cm);
    int h2=hashFunc2(cm);
    printf("###%d", h2);
    while(hmap[h1]!=0) {
	if(hmap[h1]==h2)
	    return true;
	h1=h1*3%1000000;
    }
    return false;
    
}

queue<char> que;
//set<char[26], bool> combs;

char currComb[26];

int main() {


    scanf("%d\n", &k);
    while(k!=0) {
	for(int i=0;i<1000010;i++) {
	    hmap[i]=0;
	}
 
	    
	gets(buf);
	int i=0;
	while(buf[i]!=0) {
	    if(isAlpha(buf[i]))
		buf[i]=lcase(buf[i])-'a';
	    else
	        buf[i]=200;
	    i++;
	}
	int total=i;
	if(total<=k) {
	    //printf("%d\n", total);
	    continue;
	}
	int cnt=0;
	i=0;
	//printf("k:%d", k);
	while(i<k) {
	    if(buf[cnt]<100) {
		//printf("in\n");
		que.push(buf[cnt]);
		currComb[buf[cnt]]++;
		i++;
		//printf("inner\n");
	    }
	    //printf("outer\n");
	    cnt++;
	}
	//printf("i:%d cnt:%d\n", i, cnt); 
	while(cnt<total) {
	    while( (cnt<total) && (buf[cnt]>100)) {
		cnt++;
		//printf("emptyInc\n");
	    }
	    if(cnt==total) break;
	    currComb[que.front()]--;
	    que.pop();
	    que.push(buf[cnt]);
	    currComb[buf[cnt]]++;
	    if(htContains(currComb)) {
		printf("found");
		break;
	    }
	    htInsert(currComb);
	}
	printf("%d\n", cnt);
	
	scanf("%d\n", &k);

    
    }
    return 0;
}